/*
  CPP_CONTEST=2018Enero
  CPP_PROBLEM=F
  CPP_LANG=CPP+OPENMP+MPI
  CPP_PROCESSES_PER_NODE=calisto 1
*/

#include <stdlib.h>
#include <omp.h>
#include <mpi.h>

extern void escribir(double *,int,int);

void multiplicar(int n,int ld,double *a,double *r)
{
  for(int i=0;i < n;i++)
  {
    for(int j=0;j < n;j++)
    {
      double s=r[i*ld+j];
      for(int k=0;k < n;k++)
      {
        s+=a[i*ld+k]*a[k*ld+j];
      }
      r[i*ld+j]=s;
    }
  }
}

void copiar(double *vo,int n,double *vd)
{
  for(int i=0;i < n;i++)
    vd[i]=vo[i];
}

void  sec(int n,double *A,int nodo,int np)
{
  double *R=new double[n*n];
  for(int i=0;i < n*n;i++)
    R[i]=0.;
  for (int i = 0; i < n; i++)
  {
    multiplicar(i+1,n,A,R);
  }
  copiar(R,n*n,A);
#ifdef DEBUG
  escribir(R,n,n);
#endif
  delete[] R;
}
